=== debian/changelog ===
qemu (1:3.1.6+c2-1+eagle) unstable; urgency=low

  * ['Autobuild release-candidate: ca90673d0220031dca330400ccf5816ac93517dd']

 -- shuttle <shuttle@deepin.com>  Fri, 18 Sep 2020 17:18:40 +0000
