=== debian/watch ===
version=4

opts=\
dversionmangle=s/\+dfsg.*$//,\
repacksuffix=+dfsg,\
compression=xz \
  https://download.qemu.org/ qemu-(.*)\.tar\.(?:gz|bz2|xz)
